/*
 File: wysuwyg_XFontLists.js
 Copyright: Rahul Singh
 Mail: induscrypt@gmail.com
 Source: http://wysuwyg.mozdev.org
 Referenced by: wysuwyg_library.xul
 Description: Load and save extra fonts to be used in the dropdown		
 			
*/



var WYS_XFontList={

prefservice:null,
xfontenabled:false,

 initXFontLst:function()
{

var fontarray= this.loadFromPref();
if (fontarray !=null)
populateList(fontarray);            

},

construct:function ()
{
if (this.prefservice==null)
this.prefservice = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch);
                
//if ( !this.prefservice.prefHasUserValue("wysuwyg.newfeatures.xfontenabled") ) //exists?
//		this.prefservice.setBoolPref("wysuwyg.newfeatures.xfontenabled",false);
try{
	this.xfontenabled=this.prefservice.getBoolPref("wysuwyg.newfeatures.xfontenabled");   
}catch (ex)	{ initNullState(); 	}
return this;
},

//in case prefs were deleted
initNullState : function()
{
	if (this.prefservice !=null) 
	{
	this.prefservice.setBoolPref("wysuwyg.newfeatures.xfontenabled",false);   
	this.prefservice.setCharPref("wysuwyg.newfeatures.xfontlist","" );	
	}
},

//returns null if empty or null string

loadFromPref: function()
{ 

//dump ("\n\nloadFromPref:(this.prefservice==null) : " + eval (this.prefservice==null));
if (this.prefservice==null)
this.prefservice = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch);
                
var rawstr=null;              
                
try{
rawstr= this.prefservice.getCharPref("wysuwyg.newfeatures.xfontlist");
}catch (ex)	{ initNullState(); 	}

if ( (rawstr ==null) || (rawstr.length ==0) ) return null; 

var strarray=rawstr.split(';',5);

return strarray;

},




onSave:function()
{
var newpref=null;
try{
newpref=saveList( );

if (newpref != null)
 this.prefservice.setCharPref("wysuwyg.newfeatures.xfontlist",newpref);
 alert ("Done.");
 }catch (ex) {alert ("Error:\n"+ex.message);}
}


}//end class WYS_XFontList

function populateList(strarray)
{



var tboxes=document.getElementsByTagName("textbox");


for (x=0;x<strarray.length && x<5 ;x++)
	{
	 strarray1= strarray[x].split(':');
	 //dump("\n"+strarray1[0]+" ---"+ strarray1[1]);
	 tboxes[x*2+2].value=strarray1[0];
	 tboxes[x*2+3].value=strarray1[1];
	 
	}
	//alert("populated");
}

function closeList()
{
window.close();
}

function saveList( )
{
var resultstr="";
var tboxes=document.getElementsByTagName("textbox");
//var strarray=new Array(5);

for (x=0;x<5;x++)
	{
	 s1=trimString(tboxes[x*2+2].value);
	 s2=trimString(tboxes[x*2+3].value);
	 
	 	 
	 if ( (s1.length==0) || (s2.length==0)) 
	 		continue;
	 if (s2.charAt(s2.length-1)==',' ) 
	 		s2=s2.slice(0,s2.length-1);
	if( hiLiteError(s1) || hiLiteError(s2))
	 	{ 	
	 		alert ("Illegal character in row "+ eval(x+1) + "!\nOnly Alphanumerics,spaces and commas allowed.");
			return null; 
		}
	 	
	 	 	 
	 resultstr+=s1+":";
	 resultstr+=s2+";";	 
	 
	}
	//dump("\n" + resultstr);	 
	//remove trailing ';'
	resultstr=resultstr.slice(0,resultstr.length-1);
	return resultstr;
}

function trimString(str) { 
    str=str.replace(/^\s*/, '');
    str=str.replace(/\s*$/, '');
   	return str;
} 

function testFn(){
 var str="Ex2:helvatica,bumble; Ex3:helvatica,bumble,tumble;Ex4:helvatica,bumble,stumble";
 populateList(str);
 res=saveList();
 //dump("\n--Reult--"+res);
 res+="hoho: fdf dfd , fdf fd" ;
 
window.setTimeout("populateList(res)" , 6000);

res+="hoho: fdf dfd , fdf fd;aaa: fdf f;ssss:fdfd dfd;dfdf: fdf" ; 
window.setTimeout("populateList(res)" , 6000);
var str2=saveList();
//dump ( "\n\n"+str.length+ "="+ str2.length+"?");

}


function hiLiteError(str)
{
 
	 if ((str.search(/[^\w\s,\d]/))!=-1)
	 { 
	  
	  return true;
	 }
	 return false;
}

/*
function startFontList()
{
WYS_XFontList.initXFontLst();

}
*/
